import time
import paho.mqtt.client as mqtt  #import the client1
import time
import subprocess
from xml.dom.minidom import parse
import xml.dom.minidom
import urllib.request, urllib.error, urllib.parse
import ssl

degree_sign= '\N{DEGREE SIGN}' 

def on_connect(client, userdata, flags, rc):
    m="Connected flags"+str(flags)+"result code "\
    +str(rc)+"client1_id  "+str(client)
    print(m)

def on_message(client1, userdata, message):
    print(("message received  "  ,str(message.payload.decode("utf-8"))))


while True:
    try:
        url = "http://www.meteo.si/uploads/probase/www/fproduct/text/sl/forecast_SI_DOLENJSKA_latest.xml"
        request = urllib.request.Request(url)
        response = urllib.request.urlopen(request, context=ssl._create_unverified_context())
        
        contents = response.read()
        
        DOMTree = xml.dom.minidom.parseString(contents)
        collection = DOMTree.documentElement
        meteoData = collection.getElementsByTagName("metData")
        
        broker_address="192.168.2.22"
        
        forecastDay = 0
        
        client1 = mqtt.Client("P1")    #create new instance
        client1.on_connect= on_connect        #attach function to callback
        client1.on_message=on_message        #attach function to callback
        time.sleep(1)
        client1.username_pw_set("USERxxx","PASSyyy")
        client1.connect(broker_address)      #connect to broker
        client1.loop_start()    #start the loop        
        
        for md in meteoData:
            time.sleep(1)
            forecastDay += 1
            domainTitle =  md.getElementsByTagName("domain_title")[0]
            valid_day = md.getElementsByTagName("valid_day")[0]
            nnShortText =  md.getElementsByTagName("nn_shortText")[0]
            tnsyn =  md.getElementsByTagName("tnsyn")[0]
            txsyn =  md.getElementsByTagName("txsyn")[0]
            day = valid_day.childNodes[0].data
            newday = day.replace(" CEST", "")
            newday = day.replace(" CET", "")
                
            client1.publish("forecast" + str(forecastDay) + "/dayname",newday,0,True)
            client1.publish("forecast" + str(forecastDay) + "/min",tnsyn.childNodes[0].data,0,True)
            client1.publish("forecast" + str(forecastDay) + "/max",txsyn.childNodes[0].data,0,True)
            client1.publish("forecast" + str(forecastDay) + "/shorttext",nnShortText.childNodes[0].data,0,True)
            
        time.sleep(5)
        client1.disconnect()
        client1.loop_stop()
        #time.sleep(4)
        #count += 1
            
        time.sleep(21590)
    except:
        print("error")
        time.sleep(600)
