import time
import paho.mqtt.client as mqtt  #import the client1
import time
import subprocess
from xml.dom.minidom import parse
import xml.dom.minidom
import urllib.request, urllib.error, urllib.parse
#import pydevd
import ssl

#pydevd.settrace("192.168.2.21", port=5678)

degree_sign= '\N{DEGREE SIGN}' 

def on_connect(client, userdata, flags, rc):
    m="Connected flags"+str(flags)+"result code "\
    +str(rc)+"client1_id  "+str(client)
    print(m)

def on_message(client1, userdata, message):
    print(("message received  "  ,str(message.payload.decode("utf-8"))))


while True:
    try:
        url = "http://www.meteo.si/uploads/probase/www/observ/surface/text/sl/observationAms_TREBNJE_latest.xml"
        request = urllib.request.Request(url)
        response = urllib.request.urlopen(request, context=ssl._create_unverified_context())
        
        contents = response.read()
        
        DOMTree = xml.dom.minidom.parseString(contents)
        collection = DOMTree.documentElement
        
        meteoData = collection.getElementsByTagName("metData")[0]
        domainTitle =  meteoData.getElementsByTagName("domain_longTitle")[0]
        valid = meteoData.getElementsByTagName("valid")[0]
        rh = meteoData.getElementsByTagName("rh")[0]
        t = meteoData.getElementsByTagName("t")[0]
        
        print(domainTitle.childNodes[0].data)
        print(rh.childNodes[0].data + "%")
        print(t.childNodes[0].data + degree_sign + "C")
        print(valid.childNodes[0].data)
        
        broker_address="192.168.2.22"
        
        client1 = mqtt.Client("P1")    #create new instance
        client1.on_connect= on_connect        #attach function to callback
        client1.on_message=on_message        #attach function to callback
        time.sleep(1)
        client1.username_pw_set("USERxxx","PASSyyy")
        client1.connect(broker_address)      #connect to broker
        client1.loop_start()    #start the loop
        client1.publish("arso/temperature",str(t.childNodes[0].data),0,True)
        client1.publish("arso/rh",str(rh.childNodes[0].data),0,True)
        client1.publish("arso/valid",str(valid.childNodes[0].data),0,True)
        client1.publish("arso/city",str(domainTitle.childNodes[0].data),0,True)
        time.sleep(5)
        client1.disconnect()
        client1.loop_stop()
        time.sleep(4)
        #count += 1
            
        time.sleep(3593)
    except:
        print("error")
        time.sleep(600)
